package com.unipi.talepis.protal2023_2.functional;

import com.unipi.talepis.protal2023_2.StudentV1;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Supplier;
import java.util.stream.Collectors;

public class Demo {
    public static void main(String[] args) {
        List<StudentV1> students = new ArrayList<>();
        students.add(new StudentV1("Pavlos",2.5f));
        students.add(new StudentV1("Maria",7.5f));
        students.add(new StudentV1("Eirini",5f));
        students.add(new StudentV1("Lykourgos",4.5f));
        students.add(new StudentV1("Thanasis",9.5f));
        students.add(new StudentV1("Ioannis",6f));

        //Βρείτε τους φοιτητές που έχουν μέσο όρο από 5 και πάνω,
        //ταξινομήστε τους βάσει μέσου όρου απτον μεγαλύτερο
        // στον μικρότερο και αυτούς που έχετε
        // βάλτε τους σε μια νέα λίστα.
        // Εκτυπώστε τα περιεχόμενα της νέας λίστας.

        List<StudentV1> newList =
                students.stream()
                        .filter(s->s.getAverage()>=5)
                        .sorted(Comparator.comparing(StudentV1::getAverage).reversed())
                        .toList();
        newList.forEach(s-> System.out.println(s));

        Supplier<Integer> ageSupplier = ()->25;
        System.out.println(ageSupplier.get());
        Consumer<Integer> integerConsumer = integer -> System.out.println("Hello "+integer);
        integerConsumer.accept(5);
        integerConsumer.accept(45);
        Function<String,Boolean> myFunction = s->s.startsWith("E");
        System.out.println(myFunction.apply("Vagelis"));
        System.out.println(myFunction.apply("Efthimios"));
    }
}
